# Contribution Guidelines

Although these projects were begun by IQVIA, we hope that they can become community efforts, and we welcome outside developers.

We hope these guidelines will help provide a good experience for the community when interacting with fellow users and developers. Using these guidelines can make it easier for contributions to be integrated.

## Issue templates

We have set up some templates that you can use to shape your text when creating issues.

When giving a new issue a title, GitHub will suggest previous issues that seem similar. It's worth checking those out to see if your problem or idea has already been reported, in which case it's better to add to that existing issue.

### Reporting bugs

[Here is our bug reporting template.](.github/ISSUE_TEMPLATE/bug_report.md)
[Here is our feature request template.](.github/ISSUE_TEMPLATE/feature_request.md)

Allowing developers to reproduce the bug you have found is crucial to beginning to look for the problem. Please provide as much information as you can and, if possible, a small example that triggers the problem.

### Requesting new features

While we can't make a commitment to developing all feature requests in the project, we'd like to hear your ideas about what you'd like to see, and maybe other community members will pick up what we can't prioritise.

## Pull Request template

[Here is our pull request template.](.github/pull_request_template.md) This is based on [stevemao/github-issue-templates](https://github.com/stevemao/github-issue-templates).

If you are going to work on the code, it's worth commenting on the issue first. Ask questions, clarify your understanding, and make sure that nobody else is going to duplicate the work. Other community members may have ideas about that issue that they haven't written about yet and your comments may bring them to respond.

If you have an idea that doesn't have an issue, it's worth making an issue first, even if you can put together the code and Pull Request very quickly.

If you are not sure if your Pull Request is designed correctly or will address the corresponding issue, draft it early and we can give you feedback.

## Style guide

We follow Invenia's [Blue](https://github.com/invenia/BlueStyle) style guide for Julia. Please adhere to this style in your contributions, and if you find some existing code that does not conform to the style, pull requests are welcome!

## Where to start

The site you are currently looking at is GitHub. It's a collaboration tool that lets people all around the world, including you, make contributions to projects like this one.

### How to get started with GitHub?

If you want to help out with our project you'll need a GitHub account. If you don't have one already you can [sign up here](https://github.com/join). Then take a look at [the tutorial here](https://guides.github.com/activities/hello-world/) for the basics of how to use the site.

### How to get started with Julia?

If you've never used the Julia language before, welcome! It's a powerful language yet very easy to learn, even if you have no experience with Python, R or MATLAB. The best place to start is the free [Julia Academy Intro](https://juliaacademy.com/p/intro-to-julia) tutorial.

### What to work on?

A great way to start getting involved is to take a look at the issue list for items marked `good first issue`. You can filter such items by [clicking here](https://github.com/IQVIA-ML/TreeParzen.jl/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22). These issues require less knowledge of the project or Julia, or require simple changes in many places that can give you a tour of the code while you implement.
